/*****************************************************************************
 
            Copyright (c)2007 Geovariances, Avon, France.
 
    In consideration  of payment of  the license fee,  which is a part of
    the price you  paid for this  product, Geovariances (GV) as licensor,
    grants you, the licensee, a non-exclusive right to use this copy of a
    GV software product.
    GV reserves all rights not  expressly granted to licensee. GV retains
    titleship and ownership  of software.  This license is not  a sale of
    the original  software or any  copy. GV also  retains  titleship  and
    ownership of any modifications or  derivations of this software.  Any
    modifications of this software  must be clearly marked as such.  This
    copyright message must  appear in its entirety  in this software,  or
    any modifications or derivations thereof.
 
    Geovariances welcomes any comments, suggestions, bug reports, etc. At
    the discretion  of Geovariances,  any customer  supplied  bug  fixes,
    enhancements, or utility codes will be distributed in future software
    releases (the contributor will of course be credited).
 
            Geovariances
            49bis, Avenue Franklin Roosevelt
            77210 Avon, FRANCE
 
             Phone: +33-(0)-160.749.100
               Fax: +33-(0)-164.228.728
            e-mail: support@geovariances.fr
 
                        All Rights Reserved
 
*****************************************************************************/
 
#include <GTXClientP.h>

static char svnid[] _GTX_UNUSED = "$Id: close_client.c 11153 2007-11-15 14:52:49Z foucher $";

#if !defined(winnt)
#include <unistd.h>
#endif

/****************************************************************************
**
** FUNCTION:    _gtx_close_client
**
** DESCRIPTION: terminates the client connection
**
** RETURNS:     Nothing
**
** ARGUMENTS:   None
**
*****************************************************************************/
void _gtx_close_client(void)
{
  int i;

  _gtx_debug("Ending session.");
  _gtx_close_socket(&_gtx_server_socket);

  /* Free Supported request list */
  if (_gtx_client_supported_requests)
  {
    for (i = 0; i < _gtx_client_n_supported_requests; i++)
      if (_gtx_client_supported_requests != NULL)
        free(_gtx_client_supported_requests[i]);
    free(_gtx_client_supported_requests);
    _gtx_client_supported_requests = NULL;
    _gtx_client_n_supported_requests = 0;
  }

  _gtx_winsock_free();
}
